diff --git a/criu/parasite-syscall.c b/criu/parasite-syscall.c
index 0fe7e834d3..9b739825e9 100644
--- a/criu/parasite-syscall.c
+++ b/criu/parasite-syscall.c
@@ -1138,7 +1138,7 @@ int parasite_unmap(struct parasite_ctl *ctl, unsigned long addr)
 	pid_t pid = ctl->pid.real;
 	int ret = -1;
 
-	ret = parasite_run(pid, PTRACE_SYSCALL, addr, NULL, &regs, &ctl->orig);
+	ret = parasite_run(pid, PTRACE_SYSCALL, addr, ctl->rstack, &regs, &ctl->orig);
 	if (ret)
 		goto err;
 
